#line 1 "C:/Users/martin/Documents/proteus/Temperature_Controller/Temperature_controller_lm35.c"
#line 26 "C:/Users/martin/Documents/proteus/Temperature_Controller/Temperature_controller_lm35.c"
unsigned short mask(unsigned short num);
unsigned int adc_rd;
long tlong;
char dato = 0, select=0, e0=1, e1=1, e2=1;
short int j;
const int factor=150;

void set_up() {

 ANSEL = 0x0D;
 ANSELH = 0;
 TRISA = 0x0D;
 ADCON1.F4 = 1;
 ADCON1.F5 = 1;
 C1ON_bit = 0;
 C2ON_bit = 0;
 CCP1CON = 0;
 CCP2CON = 0;
 TRISB = 0;
 TRISD = 0;
 TRISC = 0xF0;
 PORTB = 0;
 PORTC = 0;
 PORTD = 0;

}

void temperature() {

 unsigned char ch1, ch2, ch3;
 short int i;

 for (i=0; i<=80; i++) {
 ch1 = tlong / 100;
 PORTD = 1;
 PORTB = mask(ch1) ;
 delay_ms(2);
 ch2 = (tlong/10) % 10 ;
 PORTD = 2;
 PORTB = mask(ch2) ;
 delay_ms(2);
 ch3 = tlong % 10;
 PORTD = 4;
 PORTB = mask(ch3) ;
 delay_ms(2);
 }
}

void Adjust_Temp() {
 unsigned char ch1, ch2, ch3;

 ch1 = dato / 100;
 PORTD = 1;
 PORTB = mask(ch1) ;
 delay_ms(2);
 ch2 = (dato/10) % 10 ;
 PORTD = 2;
 PORTB = mask(ch2) ;
 delay_ms(2);
 ch3 = dato % 10;
 PORTD = 4;
 PORTB = mask(ch3) ;
 delay_ms(2);

}

void main() {

 set_up();
 do {
 adc_rd = ADC_Read(0);
 delay_ms(1);
 tlong = (long)adc_rd * factor;
 tlong = tlong / 1023;

 if(select==1){
 if(tlong == dato) PORTC = 2;
 if(tlong > dato) PORTC = 1;
 if(tlong < dato) PORTC = 4;
 }
 if(select==0){
 if(tlong == dato) PORTC = 10;
 if(tlong > dato) PORTC = 8;
 if(tlong < dato) PORTC = 8;

 }

 if (Button(&PORTC,4,1,0)) Adjust_Temp();
 if (Button(&PORTC,4,1,1)) temperature();

 if (Button(&PORTC,5,1,0)) e2=0;
 if (e2==0 && Button(&PORTC,5,1,1)){
 select++;
 if (select>1) select=0;
 e2=1;
 }
 if (Button(&PORTC,7,1,0)) e0=0;
 if (e0==0 && Button(&PORTC,7,1,1)){
 dato++;
 if (dato>150) dato=0;
 e0=1;
 }
 if (Button(&PORTC,6,1,0)) e1=0;
 if (e1==0 && Button(&PORTC,6,1,1)){
 dato--;
 if (dato==255) dato=150;
 e1=1;
 }
 if (Button(&PORTC,6,10,0) && Button(&PORTC,7,10,0)){
 dato++;
 if (dato>150) dato=0;
 for (j=0; j<=50; j++) {
 Adjust_Temp();
 }
 }
 } while (1);
}
